<script setup lang="tsx">
import { ContentWrap } from '@/components/ContentWrap'
import { Search } from '@/components/Search'
import { Dialog } from '@/components/Dialog'
import { useI18n } from '@/hooks/web/useI18n'
import { ElButton, ElLink } from 'element-plus'
import { Table } from '@/components/Table'
import {
  getTableListApi,
  saveTableApi,
  delTableListApi
} from '@/api/trustedZoneManage/actionLogQuery'
import { useTable } from '@/hooks/web/useTable'
import { TableData } from '@/api/table/types'
import { ref, unref, reactive } from 'vue'
import Write from './components/Write.vue'
import Detail from './components/Detail.vue'
import { CrudSchema, useCrudSchemas } from '@/hooks/web/useCrudSchemas'

defineOptions({
  name: 'ActionLogQuery'
})

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getTableListApi({
      pageNum: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.data.list,
      total: res.data.total
    }
  },
  fetchDelApi: async () => {
    const res = await delTableListApi(unref(ids))
    return !!res
  }
})
const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const searchParams = ref({})
const setSearchParams = (params: any) => {
  searchParams.value = params
  getList()
}

const { t } = useI18n()

const crudSchemas = reactive<CrudSchema[]>([
  {
    field: 'organName',
    label: '机构名称',
    search: {
      hidden: true
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'organCode',
    label: '机构编号',
    search: {
      hidden: true
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'loggingTime',
    label: '记录时间',
    search: {
      component: 'DatePicker',
      componentProps: {
        type: 'daterange'
      }
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'actionDate',
    label: '操作日期',
    search: {
      component: 'DatePicker',
      componentProps: {
        type: 'daterange'
      }
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'actionTime',
    label: '操作时间',
    search: {
      hidden: true
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'actionAccount',
    label: '操作账号',
    search: {
      hidden: false,
      component: 'Input'
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'actionIp',
    label: '操作IP',
    search: {
      hidden: false,
      component: 'Input'
    },
    form: {
      component: 'Input'
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'actionType',
    label: '操作类型',
    search: {
      hidden: false,
      component: 'Select',
      componentProps: {
        options: [
          {
            label: '执行',
            value: 1
          },
          {
            label: '修改',
            value: 2
          },
          {
            label: '查询',
            value: 3
          }
        ]
      },
      value: 1
    },
    form: {
      component: 'Select',
      componentProps: {
        options: [
          {
            label: '执行',
            value: 1
          },
          {
            label: '修改',
            value: 2
          },
          {
            label: '查询',
            value: 3
          }
        ]
      },
      value: 1
    },
    detail: {
      hidden: false
    }
  },
  {
    field: 'action',
    width: '60px',
    label: t('tableDemo.action'),
    search: {
      hidden: true
    },
    form: {
      hidden: true
    },
    detail: {
      hidden: true
    },
    table: {
      slots: {
        default: (data: any) => {
          return (
            <>
              <ElLink type="primary" underline={false} onClick={() => action(data.row, 'detail')}>
                {t('exampleDemo.detail')}
              </ElLink>
            </>
          )
        }
      }
    }
  }
])

// @ts-ignore
const { allSchemas } = useCrudSchemas(crudSchemas)

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref<TableData | null>(null)
const actionType = ref('')

const AddAction = () => {
  dialogTitle.value = t('exampleDemo.add')
  currentRow.value = null
  dialogVisible.value = true
  actionType.value = ''
}

const delLoading = ref(false)

const delData = async (row: TableData | null) => {
  const elTableExpose = await getElTableExpose()
  ids.value = row ? [row.id] : elTableExpose?.getSelectionRows().map((v: TableData) => v.id) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

const action = (row: TableData, type: string) => {
  dialogTitle.value = t(type === 'edit' ? 'exampleDemo.edit' : 'exampleDemo.detail')
  actionType.value = type
  currentRow.value = row
  dialogVisible.value = true
}

const writeRef = ref<ComponentRef<typeof Write>>()

const saveLoading = ref(false)

const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveTableApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: any[]) => {
  disabled.value = selection.length === 0
}
</script>

<template>
  <ContentWrap>
    <Search :schema="allSchemas.searchSchema" @search="setSearchParams" @reset="setSearchParams" />

    <Table
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      :columns="allSchemas.tableColumns"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total: total
      }"
      @register="tableRegister"
      @refresh="refresh"
      @selection-change="onSelectionChange"
    >
      <template #buttons>
        <ElButton type="primary" @click="AddAction">{{ t('exampleDemo.add') }}</ElButton>
        <ElButton :loading="delLoading" type="primary" :disabled="disabled" @click="delData(null)">
          {{ t('exampleDemo.del') }}
        </ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write
      v-if="actionType !== 'detail'"
      ref="writeRef"
      :form-schema="allSchemas.formSchema"
      :current-row="currentRow"
    />

    <Detail
      v-if="actionType === 'detail'"
      :detail-schema="allSchemas.detailSchema"
      :current-row="currentRow"
    />

    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('exampleDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>
